Strict
Graphics 800 , 600
AppTitle = "AlienMassacre"
SetClsColor 90,90,90;SetMaskColor 255,0,255
Global menu,gamestart,appear,massacredaliens,ergebnis
Global screen:TImage=LoadImage("gfx/screen.jpg"),screen2:TImage=LoadImage("gfx/screen2.jpg")
Global Schr:TImagefont = LoadImageFont("Font.ttf" , 30) ; SetImageFont Schr
Global SoundLoop:TSound = LoadSound("loop.wav" , SOUND_LOOP); Global channel:TChannel =PlaySound(SoundLoop)

Global TPl:Pl=New Pl

'--------------------
'-----MAIN LOOP
'--------------------
SetBlend alphablend
Repeat
	Select menu
		Case 0
			DrawImage screen , 0 , 0
			SetColor 90,90,90
			DrawText "Press Space to beginn",200,550 ' In Bild aufnehmen
			SetColor 255,255,255
			If KeyHit(Key_Space) Then
				gamestart=MilliSecs()
				menu = 1
			EndIf 
		Case 1
			SetColor 105,105,105
			DrawRect 20 , 40 , 760 , 540
			SetColor 255,255,255
			appear=Rand(1,100); If appear >98 Alien.Create()
			Alien.UpdateAll()
			Acid.UpdateAll()
			TPl.Draw()
			SetColor 105,105,105
			DrawText "Time: " + (gamestart - MilliSecs() + 60000) / 100 , 310 , 5
			DrawText "Energy: " + TPl.energy , 160 , 5 ; DrawText "Energy: " + TPl.energy , 460 , 5
			DrawText "Alienz: "+ Massacredaliens,5,5;DrawText "Alienz: "+ Massacredaliens,630,5
			If (gamestart+60000)<MilliSecs() menu=2
		Case 2
			SetColor 255,255,255
			DrawImage screen2 , 0 , 0
			SetColor 50,50,50
			DrawText massacredaliens , 300 , 180
			DrawText "- " + TPl.energy , 480 , 230
			ergebnis = massacredaliens-TPl.energy
			DrawText ergebnis , 310 , 460
			SetScale 2.0,2.0
			If ergebnis < 0 Then
				DrawText "Du Noob" , 380 , 500
			ElseIf ergebnis > - 1 And ergebnis < 20 Then
				DrawText "Anfaenger" , 380 , 500
			ElseIf ergebnis > 19 And ergebnis < 50 Then
				DrawText "Soldat",380,500
			ElseIf ergebnis > 49 Then
				DrawText "Elite",380,500
			EndIf
			SetScale 1.0,1.0
	End Select
	Flip;Cls
Until KeyDown(Key_Escape) Or AppTerminate()

'--------------------
'-----TYPES
'--------------------
Type Pl
	Field x = 100 , y = 200 ,frame:Float,bamm,bammY,bammstart,nextcloud,energy
	Field plgfx:TImage=LoadAnimImage("gfx/pl.bmp",20,20,0,4),plba:TImage=LoadImage("gfx/bamm.bmp")
	Field sound:TSound=LoadSound("acid.wav")

	Method Draw()
		If frame<3 frame:+0.1 Else frame=0
		If KeyHit(Key_enter) Then
			bamm = 1
			PlaySound sound
			energy:+1
			bammstart= MilliSecs()
		EndIf
		If bamm>0 DrawImage plba,X+2,Y+bammY
		If bamm = 1 And bammY < 16 bammY:+ 1
		If bammY > 15 Then
			Nextcloud =Rand(0,5)
			If Nextcloud = 0 Acid.Create((x+4),(y+16))
		EndIf 
		If (bammstart + 2000) < MilliSecs() Then
			bamm = 0
			bammY=0
		EndIf
		DrawImage plgfx , X , Y,frame
		If KeyDown(Key_A) And X > 20 X:-1
		If KeyDown(Key_D) And X < 760 X:+1
		If KeyDown(Key_W) And Y > 40 Y:-1
		If KeyDown(Key_S) And Y < 560 Y:+ 1
	End Method
End Type

Type Alien
	Field x , y , alive, moves,moves2,xdir,ydir
	Field gfx:TImage = LoadImage("gfx/alien.bmp"),blood:TImage=LoadImage("gfx/blood.bmp")
	Field sound:TSound=LoadSound("sizzle.wav")
	Global AlienList:TList
	
	Function Create()
		Local NewAlien:Alien
		NewAlien = New Alien
		NewAlien.X = Rand(20 , 740)
		NewAlien.Y = Rand(40 , 540)
		NewAlien.alive = 1
		If Not AlienList Then AlienList = CreateList()
		AlienList.addlast(NewAlien)
	End Function
	
	Function UpdateAll()
		If Not AlienList Return
		For Local aliens:alien = EachIn AlienList
			aliens.Draw()
			aliens.Move()
		Next
	End Function
	
	Method Draw()
		Select alive
			Case 1
				DrawImage gfx , x , y
			Case 0
				DrawImage blood,x,y
			Case 2
				SetColor 100,100,100
				DrawImage gfx , x , y
				SetColor 255,255,255
		End Select
		If Not Acid.Cloudlist Return
		SetColor 0,0,0
		For Local cloud:acid = EachIn Acid.CloudList
			If ImagesCollide(gfx , x , y , 0 , cloud.gfx , cloud.x , cloud.y , 0) And alive>0 Then
				Select alive
					Case 1
						massacredaliens:+1	
					Case 2
						massacredaliens:+2
				End Select
				PlaySound sound
				alive=0
			EndIf 
		Next
		SetColor 255,255,255
	End Method
	
	Method Move()
	If alive >0
		moves=Rnd(0,10000)
		If moves <9995 Then
			moves2=Rnd(0,10000)
			If moves2<41
				xdir=Rand(-1,1)
				ydir=Rand(-1,1)
			ElseIf moves2>50
				xdir=xdir
				ydir=ydir
			Else 
				xdir=0
				ydir=0
			EndIf
		Else
			alive=2
		EndIf
		If x<20 Or x>764 Or y<40 Or y>574 Then 
			xdir=-xdir
			ydir=-ydir
		EndIf
		x:+xdir
		y:+ydir
	EndIf 
	End Method
End Type

Type Acid
	Field x:Float , y:Float , xdir:Float, ydir:Float, start, alphastart:Float, alpha:Float,  gfx:TImage = LoadImage("gfx/acid.bmp")
	Global CloudList:TList
	
	Function Create(x,y)
		Local NewCloud:Acid
		NewCloud = New Acid
		NewCloud.X = X
		NewCloud.Y = Y
		NewCloud.xdir = Rnd( - 1 , +1)/5
		NewCloud.ydir = Rnd( - 1 , + 1) / 5
		NewCloud.alphastart = 1.0
		NewCloud.alpha=0.005
		NewCloud.start = MilliSecs()
		If Not CloudList Then CloudList = CreateList()
		CloudList.addlast(NewCloud)
	End Function

	Function UpdateAll()
		If Not CloudList Return
		For Local clouds:Acid = EachIn CloudList
			clouds.Draw()
			If (clouds.start+3000)<MilliSecs() CloudList.remove(clouds)
		Next
		SetAlpha 1.0
	End Function
	
	Method Draw()
		SetAlpha alphastart
		alphastart:-alpha
		DrawImage gfx , x , y
		x:-xdir
		y:- ydir
	End Method
End Type